import { AutocompleteResultBase, ClickHouseAutocompleteResult, CursorPosition, EnrichAutocompleteResult, GetParseTree, LexerConstructor, MySqlAutocompleteResult, ParserConstructor, PostgreSqlAutocompleteResult } from './autocomplete-types';
import { Lexer as LexerType, Parser as ParserType } from 'antlr4ng';
import { TokenDictionary } from './shared/tables';
export declare function parseQuery<A extends AutocompleteResultBase, L extends LexerType, P extends ParserType>(Lexer: LexerConstructor<L>, Parser: ParserConstructor<P>, tokenDictionary: TokenDictionary, ignoredTokens: Set<number>, rulesToVisit: Set<number>, getParseTree: GetParseTree<P>, enrichAutocompleteResult: EnrichAutocompleteResult<A>, query: string, cursor: CursorPosition): A;
export declare function parseMySqlQueryWithoutCursor(query: string): Pick<MySqlAutocompleteResult, 'errors'>;
export declare function parseMySqlQuery(query: string, cursor: CursorPosition): MySqlAutocompleteResult;
export declare function parsePostgreSqlQueryWithoutCursor(query: string): Pick<PostgreSqlAutocompleteResult, 'errors'>;
export declare function parsePostgreSqlQuery(query: string, cursor: CursorPosition): PostgreSqlAutocompleteResult;
export declare function parseClickHouseQueryWithoutCursor(query: string): Pick<ClickHouseAutocompleteResult, 'errors'>;
export declare function parseClickHouseQuery(query: string, cursor: CursorPosition): ClickHouseAutocompleteResult;
